Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xpath.functions
Class Function2Args

    java.lang.Object
      org.apache.xpath.Expression
          org.apache.xpath.functions.Function
              org.apache.xpath.functions.FunctionOneArg
                  org.apache.xpath.functions.Function2Args

All Implemented Interfaces:
  ExpressionNode, ExpressionOwner, java.io.Serializable, SourceLocator, XPathVisitable

Direct Known Subclasses:
  FuncContains, FuncDocument, FuncKey, FuncStartsWith, FuncSubstringAfter, FuncSubstringBefore, Function3Args

public class Function2Args
extends FunctionOneArg

Base class for functions that accept two arguments.

See Also:
  Serialized Form
Usage:
  **For advanced use only**

Constructor Summary
`Function2Args()`

Method Summary
`void` | `callArgVisitors(XPathVisitor visitor)` Call the visitors for the function arguments.
`boolean` | `canTraverseOutsideSubtree()` Tell if this expression or it's subexpressions can traverse outside the current subtree.
`void` | `checkNumberArgs(int argNum)` Check that the number of arguments passed to this function is correct.
`boolean` | `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
`void` | `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
`Expression` | `getArg1()` Return the second argument passed to the function (at index 1).
`void` | `setArg(Expression arg, int argNum)` Set an argument expression for a function.

Methods inherited from class org.apache.xpath.functions.FunctionOneArg
`getArg0, getExpression, setExpression`

Methods inherited from class org.apache.xpath.functions.Function
`callVisitors, execute, postCompileStep`

Methods inherited from class org.apache.xpath.Expression
`asIterator, asIteratorRaw, asNode, assertion, bool, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Function2Args

    public Function2Args()

Method Detail

### getArg1

    public Expression getArg1()

  Return the second argument passed to the function (at index 1).

  Returns:
    An expression that represents the second argument passed to the function.

### fixupVariables

    public void fixupVariables(java.util.Vector vars,
                               int globalsSize)

  This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.

  Overrides:
    `fixupVariables` in class `FunctionOneArg`
  Parameters:
    `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

### setArg

    public void setArg(Expression arg,
                       int argNum)
                throws WrongNumberArgsException

  Set an argument expression for a function. This method is called by the XPath compiler.

  Overrides:
    `setArg` in class `FunctionOneArg`
  Parameters:
    `arg` - non-null expression that represents the argument.
    `argNum` - The argument number index.
  Throws:
    `WrongNumberArgsException` - If the argNum parameter is greater than 1.

### checkNumberArgs

    public void checkNumberArgs(int argNum)
                         throws WrongNumberArgsException

  Check that the number of arguments passed to this function is correct.

  Overrides:
    `checkNumberArgs` in class `FunctionOneArg`
  Parameters:
    `argNum` - The number of arguments that is being passed to the function.
  Throws:
    `WrongNumberArgsException`

### canTraverseOutsideSubtree

    public boolean canTraverseOutsideSubtree()

  Tell if this expression or it's subexpressions can traverse outside the current subtree.

  Overrides:
    `canTraverseOutsideSubtree` in class `FunctionOneArg`
  Returns:
    true if traversal outside the context node's subtree can occur.

### callArgVisitors

    public void callArgVisitors(XPathVisitor visitor)

  Description copied from class: `Function`
  Call the visitors for the function arguments.

  Overrides:
    `callArgVisitors` in class `FunctionOneArg`
  See Also:
    `XPathVisitable#callVisitors(ExpressionOwner, XPathVisitor)`

### deepEquals

    public boolean deepEquals(Expression expr)

  Description copied from class: `Expression`
  Compare this object with another object and see if they are equal, include the sub heararchy.

  Overrides:
    `deepEquals` in class `FunctionOneArg`
  See Also:
    `Expression.deepEquals(Expression)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 Apache XML Project. All Rights Reserved.